{
       UAV Video Overlay for
     AutoProp8 autopilot program
               By
          earl@uphi.net
            05/18/09                                                       

All this code could be modified to be smaller and more efficient I'm sure.
I ain't a very good programer !

I had lots of help from the Prop forum.......

Used modified "HITT_Video_Overlay_012" object from HITT Consulting for OSD
Modified by earl@uphi.net

Look at the HITT_Video_Overlay_012 part of the program to get a feel for what you can
do with the OSD.

The original HITT_Video_Overlay_012 object has been modified for some special chacters.

05/11/09 8PM output to 2 servos to use 6DOF data for testing...Works !
05/18/09 made compass more accurate

Whats working so far >>>>>>>

R/C RX          Radio Control RX detection and channel data decoder
Barometer       Used for Barometric Altitude and Temp.
Servo Output    To move control surfaces
6DOF            6 Degrees of Freedom Accelrometer and Gyros
GPS             GPS unit 5 updated per second
Ping Unit       Ultronic detection for altitude less than 5 feet
OSD             On Screen Display to overlay data on camera input
Camera Input    Detected by Prop to sync OSD
XBee Transiver  To send and recieve data to ground
900mhz WCT      Wireless camera transmitter for onboard video to ground
GS              Ground Station laptop software via USB XBee transiver

The ground station can send and recieve data up to several miles (10mi) from the UAV

Whats needed now is a karman filter in software and the autopilot waypoint stuff
and a whole lot more.
Sometimes I think its a neverending project !
Heve fun...enjoy

 }
CON
  _clkmode        = xtal1 + pll8x ' Overlay Object works @ 40MHz ONLY!
  _xinfreq        = 5_000_000

  cEnable = 5      'clock,data,enable pins compass for HM55B compass module
  cClock  = 6
  cData   = 7 

' GPS Assignments 
  GPSin     = 8    ' fm GPS NEMA data
  GPSout    = 9    ' to GPS (to set baud, SIRF or NMEA etc. May be needed for your GPS)

 
' RC Rx Input Assignments                              
  RxAler    = 24 'pin 4 on rx  aleron
  RxElev    = 25 'pin 5 on rx  elevator
  RxRudder  = 26 'pin 6 on rx  throtle                                                              
  RxThrot   = 27 'pin 7 on rx  rudder
  RxGear    = 11 'pin 11 on gear switch
  Ch7       =  2 'pin 2 on ch7 of my tx

' Servos Output pins
  SrvElev   = 19                                       
  SrvThrot  = 18
  SrvAle    = 20                                       
  SrvRudder = 21                                       
                               
  PING_Pin  = 10     'for close ground mesurement  
                     

OBJ
  Overlay    :  "HITT_Video_Overlay_012"
  ping       :  "ping"
  sn         :  "Simple_numbers"
  gps        :  "GPS_IO_mini_PNAV"                     
  ser        :  "FullDuplexSerialPlus"
  uart       :  "FullDuplexSerialPlus"
  uartDOF    :  "FullDuplexSerialPlusDOF"
  xb         :  "XBee_Object"
  HM55B      :  "Sensor.HM55B.Compass"
  Baro       :  "EC_i2c_readbaro"
  BS2        :  "BS2_Functions"           
  Calibrate  :  "HM55B Compass Calibration"
  fs         :  "floatstring"
  f          :  "float32"

VAR
  long temp,altitude,runningcount,ax,ay,az,gx,gy,gz,value
  long latitude,longitude,BaltitudeF
  word b6,x1,x2,x3,b3,y1,y2,y3,p,barop,up,b2,b5,ac2,ac3,ac1,b1,b4,ac4,rssi 
  word mmin,mminw,mminf,mmhg,altitudeM,Baltitude,BaltitudeM,RawHeading,deg,CorrectHeading
  byte rangeIN,gpsheading,speed,rxdof,cptr,sats,degree,osd,btb,v
  byte buffer [16]
  long   stackRC[100]                  ' Sets up a stack space for Radio Control Receiver [increase if more servos]
  long   stackXB[100]                  ' Sets up a stack space for Radio Control Receiver [increase if more servos]
  word   rx[16],data[16]               ' FROM r/c receiver from ~0350 to ~950   
                                         
PUB Start

  Overlay.init                       ' OSD stuff
  Overlay.SetMode(2)                 ' same here
  gps.start(GPSin,GPSout)            ' start GPS ingest 
  uartDOF.start (22,23,0,115200)     ' start uart on pins 22,23 for 6DOF Atomic board
  XB.start(16,17,0,9600)             ' XBee Comms - RX,TX, Mode, Baud
  HM55B.start(cEnable,cClock,cData)  ' start compass module
  Baro.init(28,29)                   ' scl and sda (i2c) on pin 28 and pin 29
  BS2.Start(30,31)                   ' need to start the bs2 routines
  f.start                            ' floting point start
  fs.SetPrecision(4)                 ' just print 4 digits of the whole numbers

cognew(RC_io,@stackRC)               ' start R/C in/out on its own cog

  DIRA[20]~~                          'make servo pin output
  DIRA[21]~~                          'make servo pin output
  DIRA[18]~~                          'make servo pin output
  DIRA[19]~~                          'make servo pin output

SplashScreen                          ' Put up OSD splash !
Init_Display

Main                                  ' start the main program




PUB Main                        ' ******** MAIN PART of PROGRAM ! *********

repeat

    Get6DOF                                           ' get the 6DOF data (6DOF = 6 Degrees of Freedom numbers)     
    PrintPitchRoll                                    ' print pitch and roll on OSD (On Screen Display)  
    GetBaroAlt                                        ' Get the Barometric altitude
    Compass                                           ' get HM55B compass data
    SendGPSXB                                         ' Send GPS data to GS (Ground Station via XBee radio)
    Send6DOFXB                                        ' send accl and gyro data to GS
    SendPitchRollXB                                   ' send pitch and roll data to GS
    SendRXXB                                          ' send R/C rx data to GS
    Display_OSD                                       ' show data on OSD

 
    
PUB Init_Display

 overlay.moveto( 10,0)          ' Moveto's place cursor at position on OSD
 overlay.putstr(string("Alt"))
  
 overlay.moveto( 195,0)
 overlay.putstr(string("Compass"))

 overlay.moveto( 123,0)
 overlay.putchar(16)             ' up indicator
 overlay.moveto( 123,16)
 overlay.putchar(17)             ' down indicator


 overlay.moveto(0,182)                  
 overlay.putstr(string("AP"))

Overlay.SetMode(2)
 
PUB Display_OSD
             

     rangeIN := ping.Inches(PING_Pin)  ' Get Range from ground In Inches via Ping device

     Overlay.SetMode(4)
     overlay.moveto( 116,153)
     overlay.putStrBig(string("    "))' erase old number

   if  rangeIN < 51                   ' If we are close to ground put data on OSD
      overlay.moveto( 118,150)
      overlay.putStrBig(sn.dec(rangeIN))
      overlay.moveto( 65,185)
      overlay.putstr(string("Ground Getting Close"))  ' A little humor here !!!
       
   else                              ' If over 50 inches from ground don't clutter display
      overlay.moveto( 65,185)
      overlay.putstr(string("                     "))

   gps.altitude                    ' Get the alt from the gps unit
   altitude :=  (((uart.StrToDec(gps.altitude)/10) * 328)/100)   'Convert GPS meters string to feet
   gps.heading                     ' Get the heading from the gps unit
   gpsheading := (uart.StrToDec(gps.heading))
   gps.speed                       ' Get the speed from the gps unit
   speed :=  (uart.StrToDec(gps.speed))

   overlay.moveto( 10,9)           ' Put the altitude on the OSD
   overlay.putStr(string("      "))             
   overlay.moveto( 10,9)
   overlay.putstr(sn.dec(altitude))              ' print gps altitude
'   overlay.putStr(fs.FloatToString(baltitudef)) ' print the string of barometric altitude      

   overlay.moveto( 215,9)          ' Put the compass heading on the OSD 
   overlay.putStr(string("     "))             
   overlay.moveto( 215,9)
   overlay.putStr(sn.dec(deg))            


                                    ' Indication for AutoPilot on/off status
    if (rx[7] > 600)
      osd := 1
          overlay.setmode(4)      
        overlay.moveto(24,182) 
      overlay.putStr(string("   "))          ' clear old data  
      overlay.moveto(24,182)                   
      overlay.putstr(string("On"))
            if osd > 0 and btb < 1           ' osd print toggle paints osd screen 1 time when 'ON'
               Init_Display                  ' Print AutoPilot Layout Screen if AP 'ON'
                btb :=1                      ' set been there before byte
    else        
          overlay.setmode(4)      
      osd := 0                               ' reset osd and btb counters (for the courious 'btb' is been there before!)
      btb := 0
          overlay.moveto(24,182) 
       overlay.putStr(string("   "))         ' clear old data  
      overlay.moveto(24,182)                  
      overlay.putstr(string("OFF"))

 if rx [6] > 700
   overlay.moveto(180,130) 
   overlay.putstr(string("Ch6 "))
   overlay.putStr(sn.dec(rx[ 6]))          ' print number rx ch 1 Pitch data
   overlay.moveto(180,140) 
   overlay.putstr(string("Ele "))
   overlay.putStr(sn.dec(rx[ 4]))          ' print number rx ch 1 Pitch data
   overlay.moveto(180,150) 
   overlay.putstr(string("Ale "))
   overlay.putStr(sn.dec(rx[ 1]))          ' print number rx ch 2 Roll data
   overlay.moveto(180,160) 
   overlay.putstr(string("Rud "))
   overlay.putStr(sn.dec(rx[ 2]))          ' print number rx ch 3 Rudder data
   overlay.moveto(180,170) 
   overlay.putstr(string("Thr "))
   overlay.putStr(sn.dec(rx[ 3]))          ' print number rx ch 4 Throttle data 
   overlay.moveto(0,172) 
   overlay.putstr(string("WP OFF"))
 else
   overlay.moveto(180,130) 
   overlay.putstr(string("        "))
   overlay.moveto(180,140) 
   overlay.putstr(string("        "))
   overlay.moveto(180,150) 
   overlay.putstr(string("        "))
   overlay.moveto(180,160) 
   overlay.putstr(string("        "))
   overlay.moveto(180,170) 
   overlay.putstr(string("        "))
     overlay.moveto(0,172) 
  overlay.putstr(string("WP On "))
 
PUB Get6DOF                                ' Get the 6DOF serial data

                                 'The 6DOF is preset in the BINARY mode at 115200 baud

read6DOF                                   ' Put the data in a buffer from 6DOF

  RunningCount := buffer[ 1]<<8 + buffer[ 2]  'Put buffer data into variables
  ax := buffer[ 3]<<8 + buffer[ 4]            'ax = acceleration
  ay := buffer[ 5]<<8 + buffer[ 6]
  az := buffer[ 7]<<8 + buffer[ 8]
  gx := buffer[ 9]<<8 + buffer[ 10]           'gx = gyro
  gy := buffer[ 11]<<8 + buffer[ 12]
  gz := buffer[ 13]<<8 + buffer[ 14]

latitude := (uart.StrToDec(gps.latitude))     'Convert string to a number for Ground Station
longitude := (uart.StrToDec(gps.longitude))   'Convert string to a number for Ground Station   
altitude :=  (((uart.StrToDec(gps.altitude)/10) * 328)/100)   'Convert GPS meters string to desimal feet
sats :=     (uart.StrToDec(gps.satellites))
gpsheading := (uart.StrToDec(gps.heading))
speed :=  (uart.StrToDec(gps.speed))
speed := speed/100

 
PUB read6DOF

 Rxdof:=0                                 ' initialize, so we know definitely what's in before checking content in the while
 repeat while Rxdof <> "A"                ' wait for the "A" to insure we are starting with
    Rxdof := uartdof.rxcheck

 cptr := 0                                ' zero the buffer pointer to start
 byte[ cptr++ ]:=Rxdof                    ' NOW the A is really in the buffer
 
 repeat while Rxdof <> "Z" and cptr < 16  ' continue to collect data until the end of sentence ("Z")
     Rxdof := uartdof.rx                  ' get character from uart Rx
     buffer[ cptr++ ] := Rxdof            ' save the character in the buff

PUB SendGPSXB

latitude := (uart.StrToDec(gps.latitude))     'Convert string to a number for Ground Station
longitude := (uart.StrToDec(gps.longitude))   'Convert string to a number for Ground Station   
altitude :=  (((uart.StrToDec(gps.altitude)/10) * 328)/100)   'Convert GPS meters string to desimal feet
sats :=     (uart.StrToDec(gps.satellites))
gpsheading := (uart.StrToDec(gps.heading))
speed :=  (uart.StrToDec(gps.speed))
speed := speed/100

xb.str(string(10,13,"!!!"))       ' Ground Station START of Sentance 

    
xb.str(string(13,"Sat:"))         ' # of GPS satilites used
xb.dec(sats)

xb.str(string(13,"LAT:"))         ' GPSlatitude
xb.dec(latitude)

xb.str(string(13,"LON:"))         ' GPSlongitude
xb.dec(longitude)

xb.str(string(13,"SPD:"))         ' GPS Ground Speed
xb.dec(speed)

xb.str(string(13,"BAR:"))         ' Barometric Altitude
'xb.str(sn.dec(BaltitudeF))
   xb.Str(sn.dec((fs.FloatToString(altitude)))) ' print the string of barometric altitude      

xb.str(string(13,"ALT:"))         ' GPS Altitude
xb.str(sn.dec(altitude))

xb.str(string(13,"IAG:"))         ' Inches Above Ground from Ping unit
xb.dec(rangeIN)
                               
xb.str(string(13,"HDD:"))         ' GPS Heading
xb.dec(gpsheading)

xb.str(string(13,"COM:"))         ' Compass Reading (HM55B)
xb.dec(degree)


PUB SendPitchRollXB
     waitcnt(clkfreq/100+cnt)     'wait a little
     
xb.str(string(13,"ROL:"))         ' Roll degree
xb.str(sn.dec((ay-510)/7*2))

xb.str(string(13,"PCH:"))         ' Pitch degree
xb.str(sn.dec((ax-500)/7*2))

PUB Send6DOFXB

     waitcnt(clkfreq/100+cnt)      'wait a little

xb.str(string(13,"ACX:"))         ' Accel X
xb.dec(ax)

xb.str(string(13,"ACY:  "))         ' Accel Y
xb.dec(ay)
  
xb.str(string(13,"ACZ:"))         ' Accel Z
xb.dec(az)
  
xb.str(string(13,"GYX:"))         ' Gyro X
xb.dec(gx)

xb.str(string(13,"GYY:"))         ' Gyro Y
xb.dec(gy)
  
xb.str(string(13,"GYZ:"))         ' Gyro Z
xb.dec(gz)

PUB SendrxXB

xb.str(string(13,"RXE:"))         ' RX Elevator
xb.dec(rx[4])

xb.str(string(13,"RXA:"))         ' RX Alieron 
xb.dec(rx[1])

xb.str(string(13,"RXR:"))         ' RX Rudder
xb.dec(rx[2])

xb.str(string(13,"RXT:"))         ' RX Throtle 
xb.dec(rx[3])
 
xb.str(string(13,"RXS:"))         ' RX AP on/off switch value
xb.dec(rx[7])
 
'xb.str(string(13,"***",13))          ' End of data sentance
xb.rxflush

PUB GetBaroAlt                         ' from the barometer module

Baro.init(28,29)                   ' scl and sda on pin 28 and pin 29
          Baro.start_adcTemp       ' start the adc then
          Baro.readBaro            ' read data via i2c bus
     
       UP := ((baro.baro_f6 * 255) + baro.baro_f7)        'raw 16 bit pressure data

       B6 := B5 - 4000                                    ' B6 = 237
       X1 := (B2 * (B6 * B6 / 4096 )) / 2048              ' X1 = 0
       X2 := (AC2 - 457) * B6 / 512                       ' X2 = -103
       X3 := ((X1 + X2) + 2) / 2                          ' X3 = -26
       B3 := (AC1 - 2218) * 2 + X3                        ' B3 = 11704
       Y1 := (AC3 -1984) * B6 / 1024                      ' Y1 = -415
       Y2 := (B1 * (B6 * B6 / 4096 )) / 65535             ' Y2 = 1
       Y3 := ((Y1 + Y2) + 2) / 2                          ' Y3 = -103
       B4 := (AC4 + 8808) * (Y3 + 32768) / 16386          ' B4 = 26781
          
       p  := ((UP - B3) * 100000) / B4                    ' p  =  95732
       X1 := (p / 255 ) * (p / 255 )                      ' X1 = 139129
       X1 := (X1 * 3038) / 65535                          ' X1 = 6449
       X2 := (- 7357 * p) / 65535                         ' X2 = -10747
       p := p + (X1 + X2 + 3791) / 8                      '  p = 95700

          value := f.FFloat(p)
          value := f.FDiv(value,101325.0)         '1013.25 * 100 since Pressure is * 100
          value := f.Pow(value, 0.190263)
          value := f.FSub(1.0, value)
          value := f.FMul(value,288.15)
          value := f.FDiv(value,0.0198122)
          value := f.FMul(value,3.28)             ' make meters into feet

          BaltitudeF := value 

 
PUB RC_IO
repeat
                                        ' Get Radio Inputs
   rx[ 1] := BS2.PULSIN( RxAler,1)      ' aleron      
   rx[ 2] := BS2.PULSIN( RxElev,1)      ' elevator
   rx[ 3] := BS2.PULSIN( RxThrot,1)     ' throttle            
   rx[ 4] := BS2.PULSIN( RxRudder,1)    ' rudder          
   rx[ 6] := BS2.PULSIN( CH7,1)         ' My Ch 7          

   rx[ 7] := BS2.PULSIN( RxGear,1)      ' Gear input switch >550 = down(AP ON) 965 = up(AP OFF)

 if (rx[7] > 600)                       ' use AP gyro if AP = ON Else use rx data

   BS2.PULSOUT(SrvAle,ay )              ' output accl y to rudder servo for testing if AP ON
   BS2.PULSOUT(SrvRudder,rx[ 1] )
   BS2.PULSOUT(SrvThrot,rx[ 3])               
   BS2.PULSOUT(SrvElev,ax)              ' output accl x to Elev servo for testing if AP ON 
 else
   BS2.PULSOUT(SrvAle,rx[ 2] )          ' output rx to rudder if AP Off
   BS2.PULSOUT(SrvRudder,rx[ 1] )
   BS2.PULSOUT(SrvThrot,rx[ 3])               
   BS2.PULSOUT(SrvElev,rx[ 4])          ' output rx to Elev if AP Off

Pub Compass

    RawHeading := HM55B.Theta                         ' Read RAW 13-bit Angle
    CorrectHeading := Calibrate.Correct(RawHeading)   ' Calibrate Correct Heading 
    Deg := CorrectHeading * 45 / 1024                 ' Convert 13-Bit Angle to Deg

Pub PrintPitchRoll


   Overlay.SetMode(4)
   overlay.moveto( 123,7)                    
   overlay.putstr(string("          "))
   overlay.moveto( 123,7)
   overlay.putStr(sn.dec((ax-500)/7*2))     ' Print Pitch in      Pitch centered at 500
   overlay.putchar(30)                      ' 2 degree increments   
                                    
                                             ' This is trickey !!!
                                             
   overlay.moveto( 115,26)                  
   overlay.putstr(string("      "))
   overlay.moveto( 115,26)
  if v := ((ay-510)/7*2)                   ' make temp var the degrees
     if v := 0                             ' if it is 0 we are level and don't print a 0
       overlay.putstr(string(" "))            ' otherwise print the degrees L or R adding on the "L" or "R"
     else
       overlay.putStr(sn.dec((ay-510)/7*2))   ' Print Roll in       Roll centered at 510
      overlay.putchar(30)                     ' 2 degree increments
      if (ay-510)/7*2  > 0
 
       overlay.putstr(string("R"))   

      else
         if (ay-510)/7*2  < 0
          overlay.putstr(string("L"))
       
Pub SplashScreen

  overlay.cls(0)                        ' clear the OSD

  Overlay.SetMode(4)

  overlay.moveto( 50,20)                    
  overlay.putstrbig(string("AutoProp8"))
  overlay.moveto( 60,50)                    
  overlay.putstrbig(string("AutoPilot"))

  overlay.moveto( 120,90)                    
  overlay.putstr(string("by"))
  overlay.moveto( 75,110)                    
  overlay.putstr(string("earl@uphi.net"))

 waitcnt(clkfreq*7+cnt)                   ' wait for 3 seconds

  overlay.cls(0)                        ' clear the OSD

       